# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
# This addon was created with the Serpens - Visual Scripting Addon.
# This code is generated from nodes and is not intended for manual editing.
# You can find out more about Serpens at <https://blendermarket.com/products/serpens>.


bl_info = {
    "name": "KRITZ CAM PRO ",
    "description": "",
    "author": "Matias Kritz",
    "version": (1, 3, 1),
    "blender": (3, 0, 0),
    "location": "",
    "warning": "",
    "wiki_url": "",
    "tracker_url": "",
    "category": "3D View"
}


###############   IMPORTS
import bpy
from bpy.utils import previews
import os
import math
from .easybpy import *


###############   INITALIZE VARIABLES
###############   SERPENS FUNCTIONS
def exec_line(line):
    exec(line)

def sn_print(tree_name, *args):
    if tree_name in bpy.data.node_groups:
        item = bpy.data.node_groups[tree_name].sn_graphs[0].prints.add()
        for arg in args:
            item.value += str(arg) + ";;;"
        if bpy.context and bpy.context.screen:
            for area in bpy.context.screen.areas:
                area.tag_redraw()
    print(*args)

def sn_cast_string(value):
    return str(value)

def sn_cast_boolean(value):
    if type(value) == tuple:
        for data in value:
            if bool(data):
                return True
        return False
    return bool(value)

def sn_cast_float(value):
    if type(value) == str:
        try:
            value = float(value)
            return value
        except:
            return float(bool(value))
    elif type(value) == tuple:
        return float(value[0])
    elif type(value) == list:
        return float(len(value))
    elif not type(value) in [float, int, bool]:
        try:
            value = len(value)
            return float(value)
        except:
            return float(bool(value))
    return float(value)

def sn_cast_int(value):
    return int(sn_cast_float(value))

def sn_cast_boolean_vector(value, size):
    if type(value) in [str, bool, int, float]:
        return_value = []
        for i in range(size):
            return_value.append(bool(value))
        return tuple(return_value)
    elif type(value) == tuple:
        return_value = []
        for i in range(size):
            return_value.append(bool(value[i]) if len(value) > i else bool(value[0]))
        return tuple(return_value)
    elif type(value) == list:
        return sn_cast_boolean_vector(tuple(value), size)
    else:
        try:
            value = tuple(value)
            return sn_cast_boolean_vector(value, size)
        except:
            return sn_cast_boolean_vector(bool(value), size)

def sn_cast_float_vector(value, size):
    if type(value) in [str, bool, int, float]:
        return_value = []
        for i in range(size):
            return_value.append(sn_cast_float(value))
        return tuple(return_value)
    elif type(value) == tuple:
        return_value = []
        for i in range(size):
            return_value.append(sn_cast_float(value[i]) if len(value) > i else sn_cast_float(value[0]))
        return tuple(return_value)
    elif type(value) == list:
        return sn_cast_float_vector(tuple(value), size)
    else:
        try:
            value = tuple(value)
            return sn_cast_float_vector(value, size)
        except:
            return sn_cast_float_vector(sn_cast_float(value), size)

def sn_cast_int_vector(value, size):
    return tuple(map(int, sn_cast_float_vector(value, size)))

def sn_cast_color(value, use_alpha):
    length = 4 if use_alpha else 3
    value = sn_cast_float_vector(value, length)
    tuple_list = []
    for data in range(length):
        data = value[data] if len(value) > data else value[0]
        tuple_list.append(sn_cast_float(min(1, max(0, data))))
    return tuple(tuple_list)

def sn_cast_list(value):
    if type(value) in [str, tuple, list]:
        return list(value)
    elif type(value) in [int, float, bool]:
        return [value]
    else:
        try:
            value = list(value)
            return value
        except:
            return [value]

def sn_cast_blend_data(value):
    if hasattr(value, "bl_rna"):
        return value
    elif type(value) in [tuple, bool, int, float, list]:
        return None
    elif type(value) == str:
        try:
            value = eval(value)
            return value
        except:
            return None
    else:
        return None

def sn_cast_enum(string, enum_values):
    for item in enum_values:
        if item[1] == string:
            return item[0]
        elif item[0] == string.upper():
            return item[0]
    return string


###############   IMPERATIVE CODE
#######   KRITZ CAM PRO 
addon_keymaps = {}


###############   EVALUATED CODE
#######   KRITZ CAM PRO 
def register_key_43047():
    kc = bpy.context.window_manager.keyconfigs.addon
    if kc:
        km = kc.keymaps.new(name="3D View", space_type="VIEW_3D")
        kmi = km.keymap_items.new("wm.call_menu_pie",
                                    type= "HOME",
                                    value= "PRESS",
                                    repeat= True,
                                    ctrl=True,
                                    alt=False,
                                    shift=False)
        kmi.properties.name = "SNA_MT_Focal_Lenghts_DC8A4"
        addon_keymaps['43047'] = (km, kmi)


class SNA_MT_Focal_Lenghts_DC8A4(bpy.types.Menu):
    bl_idname = "SNA_MT_Focal_Lenghts_DC8A4"
    bl_label = "Focal Lenghts"


    @classmethod
    def poll(cls, context):
        return True

    def draw(self, context):
        try:
            layout = self.layout
            layout = layout.menu_pie()
            op = layout.operator("sna.fl_14_mm_ultra_wide_",text=r"FL 14 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_16_mm_ultra_wide_",text=r"FL 16 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_24_mm_wide_",text=r"FL 24 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_35_mm_wide_",text=r"FL 35 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_50_mm_standard_",text=r"FL 35 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_50_mm_standard_",text=r"FL 50 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_85_mm_portrait_",text=r"FL 85 mm",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_135_mm_telephoto_",text=r"FL 135 mm",emboss=True,depress=False,icon_value=0)
        except Exception as exc:
            print(str(exc) + " | Error in Focal Lenghts pie menu")


class SNA_OT_Fstop_12(bpy.types.Operator):
    bl_idname = "sna.fstop_12"
    bl_label = "F-stop 1.2"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 1.2.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 1.2
            pass # F-stop 1.2.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 1.2")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 1.2")
        return self.execute(context)


class SNA_OT_Fstop_14(bpy.types.Operator):
    bl_idname = "sna.fstop_14"
    bl_label = "F-stop 1.4"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 1.4.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 1.4
            pass # F-stop 1.4.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 1.4")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 1.4")
        return self.execute(context)


class SNA_OT_Fstop_18(bpy.types.Operator):
    bl_idname = "sna.fstop_18"
    bl_label = "F-stop 1.8"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 1.8.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 1.8
            pass # F-stop 1.8.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 1.8")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 1.8")
        return self.execute(context)


class SNA_OT_Fstop_20(bpy.types.Operator):
    bl_idname = "sna.fstop_20"
    bl_label = "F-stop 2.0"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 2.0.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 2.0
            pass # F-stop 2.0.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 2.0")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 2.0")
        return self.execute(context)


class SNA_OT_Fstop_28(bpy.types.Operator):
    bl_idname = "sna.fstop_28"
    bl_label = "F-stop 2.8"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 2.8.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 2.8
            pass # F-stop 2.8.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 2.8")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 2.8")
        return self.execute(context)


class SNA_OT_Fstop_40(bpy.types.Operator):
    bl_idname = "sna.fstop_40"
    bl_label = "F-stop 4.0"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 4.0.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 4.0
            pass # F-stop 4.0.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 4.0")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 4.0")
        return self.execute(context)


class SNA_OT_Fstop_56(bpy.types.Operator):
    bl_idname = "sna.fstop_56"
    bl_label = "F-stop 5.6"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 5.6.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 5.6
            pass # F-stop 5.6.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 5.6")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 5.6")
        return self.execute(context)


class SNA_OT_Fstop_80(bpy.types.Operator):
    bl_idname = "sna.fstop_80"
    bl_label = "F-stop 8.0"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 8.0.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 8.0
            pass # F-stop 8.0.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 8.0")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 8.0")
        return self.execute(context)


class SNA_OT_Fstop_11(bpy.types.Operator):
    bl_idname = "sna.fstop_11"
    bl_label = "F-stop 11"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 11.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 11
            pass # F-stop 11.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 11")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 11")
        return self.execute(context)


class SNA_OT_Fstop_16(bpy.types.Operator):
    bl_idname = "sna.fstop_16"
    bl_label = "F-stop 16"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 16.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 16
            pass # F-stop 16.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 16")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 16")
        return self.execute(context)


class SNA_OT_Fstop_22(bpy.types.Operator):
    bl_idname = "sna.fstop_22"
    bl_label = "F-stop 22"
    bl_description = "Change F-stop"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # F-stop 22.py Script Start
            import bpy
            bpy.context.object.data.dof.aperture_fstop = 22
            pass # F-stop 22.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of F-stop 22")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of F-stop 22")
        return self.execute(context)


class SNA_OT_Fl_14_Mm_Ultra_Wide_(bpy.types.Operator):
    bl_idname = "sna.fl_14_mm_ultra_wide_"
    bl_label = "FL 14 mm Ultra Wide "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 14 mm Ultra Wide.py Script Start
            import bpy
            bpy.context.object.data.lens = 14
            pass # FL 14 mm Ultra Wide.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 14 mm Ultra Wide ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 14 mm Ultra Wide ")
        return self.execute(context)


class SNA_OT_Fl_16_Mm_Ultra_Wide_(bpy.types.Operator):
    bl_idname = "sna.fl_16_mm_ultra_wide_"
    bl_label = "FL 16 mm Ultra Wide "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 16 mm Ultra Wide.py Script Start
            import bpy
            bpy.context.object.data.lens = 16
            pass # FL 16 mm Ultra Wide.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 16 mm Ultra Wide ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 16 mm Ultra Wide ")
        return self.execute(context)


class SNA_OT_Fl_24_Mm_Wide_(bpy.types.Operator):
    bl_idname = "sna.fl_24_mm_wide_"
    bl_label = "FL 24 mm Wide "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 24 mm Wide.py Script Start
            import bpy
            bpy.context.object.data.lens = 24
            pass # FL 24 mm Wide.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 24 mm Wide ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 24 mm Wide ")
        return self.execute(context)


class SNA_OT_Fl_35_Mm_Wide_(bpy.types.Operator):
    bl_idname = "sna.fl_35_mm_wide_"
    bl_label = "FL 35 mm Wide "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 35 mm Wide.py Script Start
            import bpy
            bpy.context.object.data.lens = 35
            pass # FL 35 mm Wide.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 35 mm Wide ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 35 mm Wide ")
        return self.execute(context)


class SNA_OT_Fl_50_Mm_Standard_(bpy.types.Operator):
    bl_idname = "sna.fl_50_mm_standard_"
    bl_label = "FL 50 mm Standard "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 50 mm Standard.py Script Start
            import bpy
            bpy.context.object.data.lens = 50
            pass # FL 50 mm Standard.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 50 mm Standard ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 50 mm Standard ")
        return self.execute(context)


class SNA_OT_Fl_85_Mm_Portrait_(bpy.types.Operator):
    bl_idname = "sna.fl_85_mm_portrait_"
    bl_label = "FL 85 mm Portrait "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 85 mm Portrait.py Script Start
            import bpy
            bpy.context.object.data.lens = 85
            pass # FL 85 mm Portrait.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 85 mm Portrait ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 85 mm Portrait ")
        return self.execute(context)


class SNA_OT_Fl_135_Mm_Telephoto_(bpy.types.Operator):
    bl_idname = "sna.fl_135_mm_telephoto_"
    bl_label = "FL 135 mm Telephoto "
    bl_description = "Change focal length "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # FL 135 mm Telephoto.py Script Start
            import bpy
            bpy.context.object.data.lens = 135
            pass # FL 135 mm Telephoto.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of FL 135 mm Telephoto ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of FL 135 mm Telephoto ")
        return self.execute(context)

def register_key_98B10():
    kc = bpy.context.window_manager.keyconfigs.addon
    if kc:
        km = kc.keymaps.new(name="Window", space_type="EMPTY")
        kmi = km.keymap_items.new("wm.call_panel",
                                    type= "HOME",
                                    value= "PRESS",
                                    repeat= False,
                                    ctrl=False,
                                    alt=False,
                                    shift=True)
        kmi.properties.name = "SNA_PT_KRITZ_CAM_PRO__F4D1B"
        kmi.properties.keep_open = True
        addon_keymaps['98B10'] = (km, kmi)


class SNA_OT_Cam_1(bpy.types.Operator):
    bl_idname = "sna.cam_1"
    bl_label = "CAM 1"
    bl_description = "Add CAM 1 "
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 1.py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 1 focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value= 1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 1"
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 1 focus"]
            pass # CAM 1.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 1")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 1")
        return self.execute(context)


class SNA_OT_Cam_2(bpy.types.Operator):
    bl_idname = "sna.cam_2"
    bl_label = "CAM 2"
    bl_description = "Add CAM 2"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 2.py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 2 focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value= 1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 2"
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 2 focus"]
            pass # CAM 2.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 2")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 2")
        return self.execute(context)


class SNA_OT_Cam_4(bpy.types.Operator):
    bl_idname = "sna.cam_4"
    bl_label = "CAM 4"
    bl_description = "Add CAM 4"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 4.py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 4 focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value= 1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 4"
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 4 focus"]
            pass # CAM 4.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 4")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 4")
        return self.execute(context)


class SNA_OT_Cam_3(bpy.types.Operator):
    bl_idname = "sna.cam_3"
    bl_label = "CAM 3"
    bl_description = "Add CAM 3"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 3.py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 3 focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value= 1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 3"
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 3 focus"]
            pass # CAM 3.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 3")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 3")
        return self.execute(context)


class SNA_OT_Cam_4_C(bpy.types.Operator):
    bl_idname = "sna.cam_4_c"
    bl_label = "CAM 4 (C)"
    bl_description = "Add CAM 4 Constraint)"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 4 (Constraint).py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 4 (Constraint) focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value=1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 4 (Constraint)"
            #Contraint to empty 
            bpy.ops.object.constraint_add(type='TRACK_TO')
            bpy.context.object.constraints["Track To"].target = bpy.data.objects["CAM 4 (Constraint) focus"]
            bpy.context.object.constraints["Track To"].up_axis = 'UP_Y'
            bpy.context.object.constraints["Track To"].track_axis = 'TRACK_NEGATIVE_Z'
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 4 (Constraint) focus"]
            pass # CAM 4 (Constraint).py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 4 (C)")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 4 (C)")
        return self.execute(context)


class SNA_OT_Cam_3_C_(bpy.types.Operator):
    bl_idname = "sna.cam_3_c_"
    bl_label = "CAM 3 (C) "
    bl_description = "Add CAM 3 Constraint)"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 3 (Constraint).py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 3 (Constraint) focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value=1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 3 (Constraint)"
            #Contraint to empty 
            bpy.ops.object.constraint_add(type='TRACK_TO')
            bpy.context.object.constraints["Track To"].target = bpy.data.objects["CAM 3 (Constraint) focus"]
            bpy.context.object.constraints["Track To"].up_axis = 'UP_Y'
            bpy.context.object.constraints["Track To"].track_axis = 'TRACK_NEGATIVE_Z'
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 3 (Constraint) focus"]
            pass # CAM 3 (Constraint).py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 3 (C) ")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 3 (C) ")
        return self.execute(context)


class SNA_OT_Cam_2_C(bpy.types.Operator):
    bl_idname = "sna.cam_2_c"
    bl_label = "CAM 2 (C)"
    bl_description = "Add CAM 2 Constraint)"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 2 (Constraint).py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 2 (Constraint) focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value=1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 2 (Constraint)"
            #Contraint to empty 
            bpy.ops.object.constraint_add(type='TRACK_TO')
            bpy.context.object.constraints["Track To"].target = bpy.data.objects["CAM 2 (Constraint) focus"]
            bpy.context.object.constraints["Track To"].up_axis = 'UP_Y'
            bpy.context.object.constraints["Track To"].track_axis = 'TRACK_NEGATIVE_Z'
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 2 (Constraint) focus"]
            pass # CAM 2 (Constraint).py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 2 (C)")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 2 (C)")
        return self.execute(context)


class SNA_OT_Cam_1_C(bpy.types.Operator):
    bl_idname = "sna.cam_1_c"
    bl_label = "CAM 1 (C)"
    bl_description = "Add CAM 1 Constraint)"
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # CAM 1 (Constraint).py Script Start
            import bpy
            # Create Empty at cursor location
            loc = bpy.context.scene.cursor.location
            bpy.ops.object.empty_add(type='PLAIN_AXES', align='WORLD', location=(loc), scale=(1, 1, 1))
            # Rename Empty
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 1 (Constraint) focus"
            # Create camera
            bpy.ops.object.camera_add(enter_editmode=False, align='VIEW', location=(-0.00130793, -9.89894, -0.00650167), rotation=(0, -0, 0), scale=(1, 1, 1))
            bpy.ops.transform.rotate(value=1.5708, orient_axis='X', orient_type='GLOBAL', orient_matrix=((1, 0, 0), (0, 1, 0), (0, 0, 1)), orient_matrix_type='GLOBAL', constraint_axis=(True, False, False), mirror=True, use_proportional_edit=False, proportional_edit_falloff='SMOOTH', proportional_size=1, use_proportional_connected=False, use_proportional_projected=False)
            bpy.context.object.data.lens = 50
            bpy.context.object.data.passepartout_alpha = 1
            # Limits + DOF
            bpy.context.object.data.show_limits = True
            bpy.context.object.data.dof.use_dof = True
            # Rename Camera
            for obj in bpy.context.selected_objects:
                obj.name = "CAM 1 (Constraint)"
            #Contraint to empty 
            bpy.ops.object.constraint_add(type='TRACK_TO')
            bpy.context.object.constraints["Track To"].target = bpy.data.objects["CAM 1 (Constraint) focus"]
            bpy.context.object.constraints["Track To"].up_axis = 'UP_Y'
            bpy.context.object.constraints["Track To"].track_axis = 'TRACK_NEGATIVE_Z'
            # Focus Object
            bpy.context.object.data.dof.focus_object = bpy.data.objects["CAM 1 (Constraint) focus"]
            pass # CAM 1 (Constraint).py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of CAM 1 (C)")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of CAM 1 (C)")
        return self.execute(context)


class SNA_PT_KRITZ_CAM_PRO__F4D1B(bpy.types.Panel):
    bl_label = "KRITZ CAM PRO "
    bl_idname = "SNA_PT_KRITZ_CAM_PRO__F4D1B"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = 'Kritz Cam Pro'
    bl_order = 0


    @classmethod
    def poll(cls, context):
        return True

    def draw_header(self, context):
        try:
            layout = self.layout
        except Exception as exc:
            print(str(exc) + " | Error in KRITZ CAM PRO  panel header")

    def draw(self, context):
        try:
            layout = self.layout
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"CAMERAS",icon_value=240)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.cam_1",text=r"CAM 1",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.cam_2",text=r"CAM 2",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.cam_3",text=r"CAM 3",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.cam_4",text=r"CAM 4",emboss=True,depress=False,icon_value=0)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"CAMERAS CONSTRAINTS",icon_value=318)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.cam_1_c",text=r"CAM 1 (C)",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.cam_2_c",text=r"CAM 2 (C)",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.cam_3_c_",text=r"CAM 3 (C)",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.cam_4_c",text=r"CAM 4 (C)",emboss=True,depress=False,icon_value=0)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 0.9700000286102295
            box.scale_y = 1.0
            box.label(text=r"FOCAL LENGHTS",icon_value=416)
            op = layout.operator("sna.fl_14_mm_ultra_wide_",text=r"FL 14 mm Ultra Wide ",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_16_mm_ultra_wide_",text=r"FL 16 mm Ultra Wide ",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_24_mm_wide_",text=r"FL 24 mm Wide ",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_35_mm_wide_",text=r"FL 35 mm Wide ",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_50_mm_standard_",text=r"FL 50 mm Standard ",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_85_mm_portrait_",text=r"FL 85 mm Portrait ",emboss=True,depress=False,icon_value=0)
            op = layout.operator("sna.fl_135_mm_telephoto_",text=r"FL 135 mm Telephoto ",emboss=True,depress=False,icon_value=0)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"F- STOPS",icon_value=872)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.fstop_12",text=r"F-stop 1.2",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.fstop_14",text=r"F-stop 1.4",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.fstop_18",text=r"F-stop 1.8",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.fstop_20",text=r"F-stop 2.0",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.fstop_28",text=r"F-stop 2.8",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.fstop_40",text=r"F-stop 4.0",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.fstop_56",text=r"F-stop 5.6",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.fstop_80",text=r"F-stop 8.0",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.fstop_11",text=r"F-stop 11",emboss=True,depress=False,icon_value=0)
            op = row.operator("sna.fstop_16",text=r"F-stop 16",emboss=True,depress=False,icon_value=0)
            row = layout.row(align=False)
            row.enabled = True
            row.alert = False
            row.scale_x = 1.0
            row.scale_y = 1.0
            op = row.operator("sna.fstop_22",text=r"F-stop 22",emboss=True,depress=False,icon_value=0)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"NAVIGATION",icon_value=53)
            op = layout.operator("view3d.walk",text=r"Walk Navigation",emboss=True,depress=False,icon_value=0)
            op = layout.operator("view3d.fly",text=r"Fly Navigation",emboss=True,depress=False,icon_value=0)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"VIEWPORT DISPLAY",icon_value=0)
            layout.prop(bpy.context.scene.camera.data,'passepartout_alpha',text=r"Passepartout Alpha",emboss=True,slider=False,)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"COMPOSITION GUIDES",icon_value=0)
            layout.prop(bpy.context.scene.camera.data,'show_composition_thirds',icon_value=0,text=r"Thirds",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_center',icon_value=0,text=r"Center",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_center_diagonal',icon_value=0,text=r"Center Diagonal",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_golden',icon_value=0,text=r"Golden Ratio",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_golden_tria_a',icon_value=0,text=r"Golden Triangle A",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_golden_tria_b',icon_value=0,text=r"Golden Triangle B",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_harmony_tri_a',icon_value=0,text=r"Harmonious Triangle A",emboss=True,toggle=False,invert_checkbox=False,)
            layout.prop(bpy.context.scene.camera.data,'show_composition_harmony_tri_b',icon_value=0,text=r"Harmonious Triangle B",emboss=True,toggle=False,invert_checkbox=False,)
            box = layout.box()
            box.enabled = True
            box.alert = False
            box.scale_x = 1.0
            box.scale_y = 1.0
            box.label(text=r"LIGHTS",icon_value=0)
            op = layout.operator("sna.random_colors",text=r"Random Colors",emboss=True,depress=False,icon_value=0)
        except Exception as exc:
            print(str(exc) + " | Error in KRITZ CAM PRO  panel")


class SNA_OT_Random_Colors(bpy.types.Operator):
    bl_idname = "sna.random_colors"
    bl_label = "Random Colors"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}


    @classmethod
    def poll(cls, context):
        return True

    def execute(self, context):
        try:
            pass # Radom Colors.py Script Start
            import bpy
            from random import uniform
            select_all_lights()
            for lights in selected_objects():
                r = uniform(0,1)
                g = uniform(0,1)
                b = uniform(0,1)
                lights.data.color = (r,g,b)
            pass # Radom Colors.py Script End
        except Exception as exc:
            print(str(exc) + " | Error in execute function of Random Colors")
        return {"FINISHED"}

    def invoke(self, context, event):
        try:
            pass
        except Exception as exc:
            print(str(exc) + " | Error in invoke function of Random Colors")
        return self.execute(context)


###############   REGISTER ICONS
def sn_register_icons():
    icons = []
    bpy.types.Scene.kritz_cam_pro__icons = bpy.utils.previews.new()
    icons_dir = os.path.join( os.path.dirname( __file__ ), "icons" )
    for icon in icons:
        bpy.types.Scene.kritz_cam_pro__icons.load( icon, os.path.join( icons_dir, icon + ".png" ), 'IMAGE' )

def sn_unregister_icons():
    bpy.utils.previews.remove( bpy.types.Scene.kritz_cam_pro__icons )


###############   REGISTER PROPERTIES
def sn_register_properties():
    pass

def sn_unregister_properties():
    pass


###############   REGISTER ADDON
def register():
    sn_register_icons()
    sn_register_properties()
    register_key_43047()
    bpy.utils.register_class(SNA_MT_Focal_Lenghts_DC8A4)
    bpy.utils.register_class(SNA_OT_Fstop_12)
    bpy.utils.register_class(SNA_OT_Fstop_14)
    bpy.utils.register_class(SNA_OT_Fstop_18)
    bpy.utils.register_class(SNA_OT_Fstop_20)
    bpy.utils.register_class(SNA_OT_Fstop_28)
    bpy.utils.register_class(SNA_OT_Fstop_40)
    bpy.utils.register_class(SNA_OT_Fstop_56)
    bpy.utils.register_class(SNA_OT_Fstop_80)
    bpy.utils.register_class(SNA_OT_Fstop_11)
    bpy.utils.register_class(SNA_OT_Fstop_16)
    bpy.utils.register_class(SNA_OT_Fstop_22)
    bpy.utils.register_class(SNA_OT_Fl_14_Mm_Ultra_Wide_)
    bpy.utils.register_class(SNA_OT_Fl_16_Mm_Ultra_Wide_)
    bpy.utils.register_class(SNA_OT_Fl_24_Mm_Wide_)
    bpy.utils.register_class(SNA_OT_Fl_35_Mm_Wide_)
    bpy.utils.register_class(SNA_OT_Fl_50_Mm_Standard_)
    bpy.utils.register_class(SNA_OT_Fl_85_Mm_Portrait_)
    bpy.utils.register_class(SNA_OT_Fl_135_Mm_Telephoto_)
    register_key_98B10()
    bpy.utils.register_class(SNA_OT_Cam_1)
    bpy.utils.register_class(SNA_OT_Cam_2)
    bpy.utils.register_class(SNA_OT_Cam_4)
    bpy.utils.register_class(SNA_OT_Cam_3)
    bpy.utils.register_class(SNA_OT_Cam_4_C)
    bpy.utils.register_class(SNA_OT_Cam_3_C_)
    bpy.utils.register_class(SNA_OT_Cam_2_C)
    bpy.utils.register_class(SNA_OT_Cam_1_C)
    bpy.utils.register_class(SNA_PT_KRITZ_CAM_PRO__F4D1B)
    bpy.utils.register_class(SNA_OT_Random_Colors)


###############   UNREGISTER ADDON
def unregister():
    sn_unregister_icons()
    sn_unregister_properties()
    bpy.utils.unregister_class(SNA_OT_Random_Colors)
    bpy.utils.unregister_class(SNA_PT_KRITZ_CAM_PRO__F4D1B)
    bpy.utils.unregister_class(SNA_OT_Cam_1_C)
    bpy.utils.unregister_class(SNA_OT_Cam_2_C)
    bpy.utils.unregister_class(SNA_OT_Cam_3_C_)
    bpy.utils.unregister_class(SNA_OT_Cam_4_C)
    bpy.utils.unregister_class(SNA_OT_Cam_3)
    bpy.utils.unregister_class(SNA_OT_Cam_4)
    bpy.utils.unregister_class(SNA_OT_Cam_2)
    bpy.utils.unregister_class(SNA_OT_Cam_1)
    bpy.utils.unregister_class(SNA_OT_Fl_135_Mm_Telephoto_)
    bpy.utils.unregister_class(SNA_OT_Fl_85_Mm_Portrait_)
    bpy.utils.unregister_class(SNA_OT_Fl_50_Mm_Standard_)
    bpy.utils.unregister_class(SNA_OT_Fl_35_Mm_Wide_)
    bpy.utils.unregister_class(SNA_OT_Fl_24_Mm_Wide_)
    bpy.utils.unregister_class(SNA_OT_Fl_16_Mm_Ultra_Wide_)
    bpy.utils.unregister_class(SNA_OT_Fl_14_Mm_Ultra_Wide_)
    bpy.utils.unregister_class(SNA_OT_Fstop_22)
    bpy.utils.unregister_class(SNA_OT_Fstop_16)
    bpy.utils.unregister_class(SNA_OT_Fstop_11)
    bpy.utils.unregister_class(SNA_OT_Fstop_80)
    bpy.utils.unregister_class(SNA_OT_Fstop_56)
    bpy.utils.unregister_class(SNA_OT_Fstop_40)
    bpy.utils.unregister_class(SNA_OT_Fstop_28)
    bpy.utils.unregister_class(SNA_OT_Fstop_20)
    bpy.utils.unregister_class(SNA_OT_Fstop_18)
    bpy.utils.unregister_class(SNA_OT_Fstop_14)
    bpy.utils.unregister_class(SNA_OT_Fstop_12)
    bpy.utils.unregister_class(SNA_MT_Focal_Lenghts_DC8A4)
    for key in addon_keymaps:
        km, kmi = addon_keymaps[key]
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()